"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Events = /** @class */ (function () {
    function Events() {
        this._eventTimes = {};
        this._queue = [];
        this._newEvents = [];
    }
    Events.prototype.emit = function (event, time) {
        if (typeof event === 'string') {
            event = { type: event };
        }
        if (event.timeDelta === undefined) {
            var lastTime = this._eventTimes[event.type];
            if (lastTime == null) {
                lastTime = time;
            }
            event.timeDelta = time - lastTime;
        }
        this._eventTimes[event.type] = time;
        this._newEvents.push(event);
    };
    Events.prototype.get = function () {
        if (this._newEvents.length > 0) {
            this._queue = this._queue.concat(this._newEvents.reverse());
            this._newEvents.length = 0;
        }
        return this._queue.pop();
    };
    return Events;
}());
exports.Events = Events;
//# sourceMappingURL=Events.js.map