"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Query_1 = require("./Query");
function toInternalSystem(system) {
    var process = isIterativeSystem(system)
        ? createProcess(system.processEntity)
        : system.process;
    return {
        query: system.query && Query_1.createQuery(system.query),
        on: system.on,
        process: process
    };
}
exports.toInternalSystem = toInternalSystem;
function isIterativeSystem(system) {
    return !system.process;
}
function createProcess(processEntity) {
    return function (entities, world, event) {
        for (var _i = 0, entities_1 = entities; _i < entities_1.length; _i++) {
            var entity = entities_1[_i];
            processEntity(entity, world, event);
        }
    };
}
//# sourceMappingURL=systems.js.map