import { Entity } from './Entity';
import { EventConstructor } from './Events';
import { Query } from './Query';
export interface World {
    readonly time: number;
    createEntity(assemblage?: (entity: Entity) => void): Entity;
    removeEntity(entity: Entity): void;
    emit(event: string | EventConstructor): void;
}
export declare class GameWorld implements World {
    private _queries;
    private _changedEntities;
    private _removedEntities;
    private _events;
    private _time?;
    constructor(_queries: Query[]);
    readonly time: number;
    createEntity(assemblage?: (entity: Entity) => void): Entity;
    private _onEntityChange;
    removeEntity(entity: Entity): void;
    emit(event: string | EventConstructor): void;
    _internal_nextEvent(): import("./Events").Event | undefined;
    _internal_tick(time: number): void;
    _internal_handleChanges(): void;
}
