export function hasAll() {
    var components = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        components[_i] = arguments[_i];
    }
    if (!components.every(isComponent)) {
        throw new Error('hasAll :: All arguments must be components.');
    }
    return function (entity) { return components.every(function (component) { return entity.has(component); }); };
}
function isComponent(componentClass) {
    return componentClass && componentClass.id;
}
//# sourceMappingURL=selectors.js.map